// file copyright BLITTE Julien
#include "main.h"

extern char Keyboard_map[5][0x59];
char buffer[4096];


int main(int argc, char *argv[]) {
	FILE *fichier;
	char preview[7];
	int BytesRead, position, i, SIWK;
	
	if (argc != 2) {
		printf("\nNtice language patch for keyboard.\n");
		printf("This patch will fix Numega SoftIce to support keyboard turned in your language.\n\n");
		printf("Usage : icekeyb <ntice.sys|winice.vxd>\n\n");
		printf("Copyrights :\n");
		printf(" + Executable file checksum fixer module by Jeremy Collake.\n");
		printf("       (collake@charter.net, www.collakesoftware.com)\n");
		printf(" + Project, map generator module and patcher by Julien Blitte.\n");
		printf("       (jblitte@ifrance.com)\n");
		printf("");
		return 0;
	}

	printf("* Trying to open file...");
	fichier = fopen(argv[1], "rb+");
	if (fichier)
		printf("ok!\n");
	else {
		printf("error!\n");
		return 1;
	}

	printf("* Generating keyboard map file for your system...");
	mapKeyboard();
	printf("done!\n");
	
	strncpy(preview, &Keyboard_map[0][0x10], 6);
	preview[6] = 0;
	printf("  Keyboard preview = [%s]\n", preview);

	printf("* Retrieving file offset...");
	
	SIWK = 0;
	do {
		position = ftell(fichier);
		BytesRead = fread(buffer, 1, sizeof(buffer), fichier);
		fseek(fichier, -4, SEEK_CUR);
		for(i=0; i <= BytesRead; i++)
			if (*((DWORD *)&buffer[i]) == 0x4B574953) // 'SIWK'
				SIWK = position + i;
	} while(BytesRead == sizeof(buffer));
	
	if (!SIWK) {
		printf("no found!\n");
		return 1;
	} else
		printf("%p\n", SIWK);
	
	printf("* Patching file...");
	fseek(fichier, SIWK+4, SEEK_SET);
	fwrite(Keyboard_map, 0x59, 5, fichier);
	fclose(fichier);
	printf("done!\n");
    
	printf("* Fixing up file checksum :");
	SetCorrectChecksum("ntice.sys");
	
	printf("\n");

	return 0;
}
