/*

Source part extracted from SetCSUM v1.00, (c)2000 Jeremy Collake
http://www.collakesoftware.com
mailto:collake@charter.net


*/
#include "setsum.h"

int SetCorrectChecksum(char *szFile)
{
		HANDLE hFile;
		HANDLE hMapping;
		unsigned char *pView;
		DWORD dwHeaderSum;
		DWORD dwCorrectSum;
		PIMAGE_NT_HEADERS pNTHeader;
		PIMAGE_DOS_HEADER pDOS;		

		DWORD nFileSize;
						
		hFile=CreateFile(szFile,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
		if(hFile==INVALID_HANDLE_VALUE)
		{
			return CHECKSUM_OPEN_FAILURE;
		}
		nFileSize=GetFileSize(hFile,NULL);
		hMapping=CreateFileMapping(hFile,0,PAGE_READWRITE,0,0,NULL);
		if(!hMapping)
		{
			CloseHandle(hFile);
			return CHECKSUM_MAP_FAILURE;
		}		
		pView=(unsigned char *)MapViewOfFile(hMapping,FILE_MAP_ALL_ACCESS,0,0,0);
		if(!pView)
		{
			CloseHandle(hMapping);
			CloseHandle(hFile);
			return CHECKSUM_MAPVIEW_FAILURE;
		}		
		pDOS=(PIMAGE_DOS_HEADER)pView;
		pNTHeader=(PIMAGE_NT_HEADERS)(pDOS->e_lfanew+(DWORD)pDOS);		
		if(pDOS->e_magic!=IMAGE_DOS_SIGNATURE
			||
			IsBadReadPtr((void *)pNTHeader,sizeof(_IMAGE_OPTIONAL_HEADER))
			||
			pNTHeader->Signature!=IMAGE_NT_SIGNATURE)
		{			
			UnmapViewOfFile((LPCVOID)pView);
			CloseHandle(hMapping);
			CloseHandle(hFile);
			return CHECKSUM_NOT_PE;
		}				
		pNTHeader=CheckSumMappedFile((LPVOID)pView,nFileSize,&dwHeaderSum,&dwCorrectSum);		
		pNTHeader->OptionalHeader.CheckSum=dwCorrectSum;
		pNTHeader=CheckSumMappedFile((LPVOID)pView,nFileSize,&dwHeaderSum,&dwCorrectSum);		
		printf("\n     Recompute\n     Header Checksum: %.8X\n     Correct Checksum: %.8X",dwHeaderSum,dwCorrectSum);
		UnmapViewOfFile((LPCVOID)pView);
		CloseHandle(hMapping);
		CloseHandle(hFile);			
		if(dwHeaderSum!=dwCorrectSum)
		{			
			return CHECKSUM_SET_ERROR;
		}
		return CHECKSUM_SUCCESS;
		
}
